Subject: bug#66224: [PATCH] Add optional PREDICATE argument to read-directory-name

From: Joseph Turner <[email-masked]>
Date: Wed, 04 Oct 2023 18:34:30 -0700

Michael Heerdegen <[email-masked]> writes:

> Joseph Turner via "Bug reports for GNU Emacs, the Swiss army knife of
> text editors" <[email-masked]> writes:
>
>> I'm not sure what you mean. In both of the following examples, PREDICATE
>> is used to narrow the completion candidates to only empty directories:
>>
>> (read-directory-name "Prompt: " "~/" nil t nil #'directory-empty-p)
>> (read-directory-name "Prompt: " "~/" nil nil nil #'directory-empty-p)
>
> In the second version also non-empty directories will be accepted.

Yes, PREDICATE narrows the completion candidates but doesn't determine a
valid return value.